/*
 *
 * j-chkmail - Mail Server Filter for sendmail
 *
 * Copyright (c) 2001, 2002, 2003, 2004 - Ecole des Mines de Paris
 *
 *  Auteur     : Jose Marcio Martins da Cruz
 *               Jose-Marcio.Martins@ensmp.fr
 *
 *  Historique :
 *  Creation     : janvier 2002
 *
 * This program is free software, but with restricted license :
 *
 * - j-chkmail is distributed only to registered users
 * - j-chkmail license is available only non-commercial applications,
 *   this means, you can use j-chkmail if you make no profit with it.
 * - redistribution of j-chkmail in any way : binary, source in any
 *   media, is forbidden
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * More details about j-chkmail license can be found at j-chkmail
 * web site : http://j-chkmail.ensmp.fr
 */


#ifndef __JLINKEDLIST_H__

typedef struct LIST_T LIST_T;

struct LIST_T
{
  LIST_T             *next;
  char               *s;
  int                 n;
  void               *data;
  size_t              size;
};

typedef   void (*LISTCLEAR_F)(void *);

LIST_T    *linked_list_add(LIST_T *, char *, int, void *, size_t);
LIST_T    *linked_list_find(LIST_T *, char *);
LIST_T    *linked_list_clear(LIST_T *, LISTCLEAR_F );

#define __JLINKEDLIST_H__
#endif
