/*
 *
 * j-chkmail - Mail Server Filter for sendmail
 *
 * Copyright (c) 2001-2004 - Ecole des Mines de Paris
 *
 *  Auteur       : Jose Marcio Martins da Cruz
 *                 Jose-Marcio.Martins@ensmp.fr
 *
 *  Historique   :
 *  Creation     : Tue Feb 21 22:09:21 CET 2006
 *
 * This program is free software, but with restricted license :
 *
 * - j-chkmail is distributed only to registered users
 * - j-chkmail license is available only non-commercial applications,
 *   this means, you can use j-chkmail if you make no profit with it.
 * - redistribution of j-chkmail in any way : binary, source in any
 *   media, is forbidden
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * More details about j-chkmail license can be found at j-chkmail
 * web site : http://j-chkmail.ensmp.fr
 */


#ifndef J_RCPT_LIST_H

typedef struct rcpt_addr_T rcpt_addr_T;

struct rcpt_addr_T
{
  char          *rcpt;
  char          *email;
  char          *host;
  char          *user;

  bool           quarantine;
  bool           deleted;
  int            access;
  rcpt_addr_T   *next;
};

#define        rcpt_count(r)    count_rcpt(r)

rcpt_addr_T   *rcpt_list_free(rcpt_addr_T *);

rcpt_addr_T   *rcpt_list_add(rcpt_addr_T **, char *, int);

int            rcpt_list_del(rcpt_addr_T **, char *rcpt);

int            count_rcpt(rcpt_addr_T *);


# define J_RCPT_LIST_H    1
#endif             /* J_RCPT_LIST_H */
